/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 *  Copyright (C) 2010, 2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *		vZbTˑW[iM16Ct@~ʕj
 *
 *  vZbTˑ̒`̂CvZbŤ^ԂɈˑȂC
 *  R8C, M32C ܂ށCM16CvZbTt@~ɋʂ鎖̒`i[D
 *
 *  ̃CN[ht@ĆC"<vZbT^>_config.h" ݂̂
 *  CN[hD̃t@C璼ڃCN[hĂ͂ȂȂD
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

/*
 *  (1) ReLXgɊւ`
 */

/* LX^bN̈̂߂̃X^bN|C^l𐶐}N */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

/*
 *  (2) VXeԂɊւ`
 */

/*
 *  CPUbNԂł̊ݗDx}XN(IPM)̒l
 *    TIPM_LOCḰCCPUbNԂ\銄ݗDx}XN(IPM)̒lD
 *    J[lǗ݂̊ɑ΂銄ݗDx̍ŏl(TMIN_INTPRI)ɓD
 */
#ifndef TIPM_LOCK
#define TIPM_LOCK	TMIN_INTPRI
#endif /* TIPM_LOCK */

/*
 *  ݗDx}XN(IPM) ƃvZbT̊ݗDxx(IPL) ̕ϊ
 *
 *  M16C ł́CtOWX^ (FLG) ̉ʂ琔12Ԗڂ14Ԗڂ܂ł
 *  3 rbgɊݗDxx (IPL) ̒li[D
 *  āCJ[l̊ǗIPM (-1A̒l) g
 *  vZbT IPL 𐧌䂷邽߂ɕϊKvƂȂD
 */
#define IPM2IPL(ipm)	(((uint16_t)(-(ipm))) << 12U)		/* IPMIPL */
#define IPL2IPM(ipl)	(-((PRI)(ipl >> 12U)))


/*
 *  ݗDx}XN̓ʂȒlɑ΂\
 */
#define IPL_LOCK	(IPM2IPL(TIPM_LOCK))  	/* CPUbNԂł IPL */
#define IPL_ENAALL	(IPM2IPL(TIPM_ENAALL))	/* TIPM_ENAALL ł IPL */



/*
 *  (3) ݏf(ݗvC)
 */

/*
 *  w芄ݔԍLȊݔԍ͈̔͂ɂ邩ǂ̔
 */
#define VALID_INTNO(intno)	((intno) < INTNO_MAX)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)

/*
 *  IPM 犄ݐ䃌WX^ł̕\ɕϊ}N
 */
#define IPM2ILVL(ipm)	(-(ipm))


/*
 *  ݐ䃌WX^֘A̒`
 */
#define INTC_LVLMASK	(0x07U)
#define INTC_IRMASK		(0x08U)
#define INTC_POLMASK	(0x10U)		/* INT݂̂ */
#define INTC_LVSMASK	(0x20U)		/* INT݂̂ */

#define INTC_POLHIGH	(0x10U)		/* INT݂̂ */
#define INTC_POLLOW		(0x00U)		/* INT݂̂ */
#define INTC_LVSEDGE	(0x00U)		/* INT݂̂ */
#define INTC_LVSLVL		(0x20U)		/* INT݂̂ */

/*
 *  (4) ݏf(݃nh)
 */

/*
 *  ݃nh̓̐}N
 */
#define _INT_ENTRY(inhno, inthdr)				_kernel_##inthdr##_##inhno##_entry
#define INT_ENTRY(inhno, inthdr)				_INT_ENTRY(inhno , inthdr)

#define _INTHDR_ENTRY(inhno, inhno_num ,inthdr)	\
		extern _kernel_##inthdr##_##inhno##_entry(void);
#define INTHDR_ENTRY(inhno, inhno_num ,inthdr)	_INTHDR_ENTRY(inhno, inhno_num ,inthdr)

/*
 *  (5) CPUOf
 */

/*
 *  CPUOnh̓̐}N
 */
#define _EXC_ENTRY(excno , exchdr)	_kernel_##exchdr##_##excno##_entry
#define  EXC_ENTRY(excno , exchdr)	_EXC_ENTRY(excno , exchdr)

#define _EXCHDR_ENTRY(excno , excno_num , exchdr) \
	extern _kernel_##exchdr##_##excno##_entry(void);
#define  EXCHDR_ENTRY(excno , excno_num , exchdr)	_EXCHDR_ENTRY(excno , excno_num , exchdr)



/*
 *  (1) ReLXgɊւ`
 */

/*
 *  ݔ񐔂ۑϐ
 *      ݂̖߂̃ReLXg𔻒f邽߂ɗpD
 */
extern uint8_t intnest;

/*
 *  ReLXg̎Q
 */
Inline bool_t sense_context(void);	/* misrac:1998 rule 71 prototype */
 
Inline bool_t
sense_context(void)
{
	/*  lXgJE^0Ȃ^XNReLXg  */
	return (intnest > 0);
}

/*
 *  (2) VXeԂɊւ`
 */
 
Inline void t_lock_cpu(void);	/* misrac:1998 rule 71 prototype */
 
Inline void i_lock_cpu(void);

Inline void t_unlock_cpu(void);

Inline void i_unlock_cpu(void);

Inline bool_t x_sense_lock(void);
Inline void x_set_ipm(PRI intpri);

#define t_set_ipm(intpri)	x_set_ipm(intpri)
#define i_set_ipm(intpri)	x_set_ipm(intpri)


Inline PRI x_get_ipm(void);


#define i_get_ipm()	x_get_ipm()
#define t_get_ipm()	t_get_ipm()

Inline bool_t x_disable_int(INTNO intno);

#define t_disable_int(intno)	x_disable_int(intno)
#define i_disable_int(intno)	x_disable_int(intno)

Inline bool_t x_enable_int(INTNO intno);

#define t_enable_int(intno)		x_enable_int(intno)
#define i_enable_int(intno)		x_enable_int(intno)


Inline void x_clear_int(INTNO intno);

#define t_clear_int(intno)		x_clear_int(intno)
#define i_clear_int(intno)		x_clear_int(intno)


Inline bool_t x_probe_int(INTNO intno);

#define t_probe_int(intno)		x_probe_int(intno)
#define i_probe_int(intno)		x_probe_int(intno)

Inline void x_define_inh(INHNO inhno, FP inthdr);

Inline void i_begin_int(INTNO intno);

Inline void i_end_int(INTNO intno);

/*
 *  (2) VXeԂɊւ`
 */

/*
 *  CPUbNԂł̊ݗDx}XN(IPM)̒l
 *    TIPM_LOCḰCCPUbNԂ\銄ݗDx}XN(IPM)̒lD
 *    J[lǗ݂̊ɑ΂銄ݗDx̍ŏl(TMIN_INTPRI)ɓD
 */
#ifndef TIPM_LOCK
#define TIPM_LOCK	TMIN_INTPRI
#endif /* TIPM_LOCK */

/*
 *  ݗDx}XN(IPM) ƃvZbT̊ݗDxx(IPL) ̕ϊ
 *
 *  M16C ł́CtOWX^ (FLG) ̉ʂ琔12Ԗڂ14Ԗڂ܂ł
 *  3 rbgɊݗDxx (IPL) ̒li[D
 *  āCJ[l̊ǗIPM (-1A̒l) g
 *  vZbT IPL 𐧌䂷邽߂ɕϊKvƂȂD
 */
#define IPM2IPL(ipm)	(((uint16_t)(-(ipm))) << 12U)		/* IPMIPL */
#define IPL2IPM(ipl)	(-((PRI)(ipl >> 12U)))


/*
 *  ݗDx}XN̓ʂȒlɑ΂\
 */
#define IPL_LOCK	(IPM2IPL(TIPM_LOCK))  	/* CPUbNԂł IPL */
#define IPL_ENAALL	(IPM2IPL(TIPM_ENAALL))	/* TIPM_ENAALL ł IPL */



/*
 *  (3) ݏf(ݗvC)
 */

/*
 *  w芄ݔԍLȊݔԍ͈̔͂ɂ邩ǂ̔
 */
#define VALID_INTNO(intno)	((intno) < INTNO_MAX)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)

/*
 *  IPM 犄ݐ䃌WX^ł̕\ɕϊ}N
 */
#define IPM2ILVL(ipm)	(-(ipm))


/*
 *  ݐ䃌WX^֘A̒`
 */
#define INTC_LVLMASK	(0x07U)
#define INTC_IRMASK		(0x08U)
#define INTC_POLMASK	(0x10U)		/* INT݂̂ */
#define INTC_LVSMASK	(0x20U)		/* INT݂̂ */

#define INTC_POLHIGH	(0x10U)		/* INT݂̂ */
#define INTC_POLLOW		(0x00U)		/* INT݂̂ */
#define INTC_LVSEDGE	(0x00U)		/* INT݂̂ */
#define INTC_LVSLVL		(0x20U)		/* INT݂̂ */

/*
 *  (4) ݏf(݃nh)
 */

/*
 *  ݃nh̓̐}N
 */
#define _INT_ENTRY(inhno, inthdr)				_kernel_##inthdr##_##inhno##_entry
#define INT_ENTRY(inhno, inthdr)				_INT_ENTRY(inhno , inthdr)

#define _INTHDR_ENTRY(inhno, inhno_num ,inthdr)	\
		extern _kernel_##inthdr##_##inhno##_entry(void);
#define INTHDR_ENTRY(inhno, inhno_num ,inthdr)	_INTHDR_ENTRY(inhno, inhno_num ,inthdr)

/*
 *  (5) CPUOf
 */

/*
 *  CPUOnh̓̐}N
 */
#define _EXC_ENTRY(excno , exchdr)	_kernel_##exchdr##_##excno##_entry
#define  EXC_ENTRY(excno , exchdr)	_EXC_ENTRY(excno , exchdr)

#define _EXCHDR_ENTRY(excno , excno_num , exchdr) \
	extern _kernel_##exchdr##_##excno##_entry(void);
#define  EXCHDR_ENTRY(excno , excno_num , exchdr)	_EXCHDR_ENTRY(excno , excno_num , exchdr)

/*
 *  (6) EI
 */

// `Ȃ

#ifndef TOPPERS_MACRO_ONLY

/*
 *  (1) ReLXgɊւ`
 */

/*
 *  (2) VXeԂɊւ`
 */

/*
 *  CPUbNtÔ߂̕ϐ (prc_config.c)
 */
#if TIPM_LOCK != -7
extern bool_t	lock_flag;	/* CPUbNtO̒l */
extern uint16_t	saved_ipl;	/* CPUbNԈڍsO̊ݗDxx */
#endif	/* TIPM_LOCK != -7	*/

/*
 *  CPU bNԂւ̈ڍs
 *      ̊֐́CCPU bNԂ̂ƂɌĂтȂƂOƂD
 */
Inline void
t_lock_cpu(void)
{
#if TIPM_LOCK == -7
	disint();
#else	/* TIPM_LOCK == -7	*/
	/* ^XNł͊ݗDx}XN̒l 0 ̂͂Ȃ̂ŕۑKvȂ */
	set_flgreg((uint16_t)((get_flgreg() & ~FLG_IPL_MASK) | IPL_LOCK));/* misrac1998 rule 77 argument type*/
	lock_flag = true;
#endif	/* TIPM_LOCK == -7	*/
}

Inline void
i_lock_cpu(void)
{
#if TIPM_LOCK == -7
	disint();
#else	/* TIPM_LOCK == -7	*/
	uint16_t	ipl;

	/*
	 *  get_flgreg() ̕Ԃl𒼐 saved_ipl ɕۑCꎞϐ
	 *  ipl ֕ۑ̂́Cget_flgreg() ̌ĂтɊ݂C
	 *  Nꂽݏ saved_ipl ύX\邽߁D
	 */
	ipl = get_flgreg();
	if (IPL_LOCK > ipl) {
		set_flgreg((uint16_t)((ipl & ~FLG_IPL_MASK) | IPL_LOCK));/* misrac1998 rule 77 argument type*/
	}
	saved_ipl = ipl;
	lock_flag = true;
#endif	/* TIPM_LOCK == -7	*/
}

/*
 *  CPUbNԂ̉
 *      ̊֐́CCPU bNԂ̂Ƃɂ̂݌Ăт邱ƂOƂD
 */
Inline void
t_unlock_cpu(void)
{
#if TIPM_LOCK == -7
	enaint();
#else	/* TIPM_LOCK == -7	*/
	lock_flag = false;
	/* ^XNs̊ݗDx}XN TIPM_ENAALL ̂͂Ȃ̂ŁCPɃNA */
	clr_ipl();
#endif	/* TIPM_LOCK == -7	*/
}

Inline void
i_unlock_cpu(void)
{
#if TIPM_LOCK == -7
	enaint();
#else	/* TIPM_LOCK == -7	*/
	lock_flag = false;
	set_flgreg((uint16_t)((get_flgreg() & ~FLG_IPL_MASK) | (saved_ipl & FLG_IPL_MASK)));/* misrac1998 rule 77 argument type*/
#endif	/* TIPM_LOCK == -7	*/
}

/*
 *  CPUbNԂ̎Q
 */
Inline bool_t
x_sense_lock(void)
{
#if TIPM_LOCK == -7
	return((bool_t)((get_flgreg() & FLG_I_MASK) == 0));
#else	/* TIPM_LOCK == -7	*/
	return lock_flag;
#endif	/* TIPM_LOCK == -7	*/
}

#define t_sense_lock()	x_sense_lock()
#define i_sense_lock()	x_sense_lock()

/*
 *  ݗDx}XN(IPM) ̐ݒ
 *    w肵ݗDx(-1, -2, ..., TMIN_INTPRI) 
 *    vZbT̊ݗDxx (IPL) ݒ肷D
 */
Inline void
x_set_ipm(PRI intpri)
{
	set_flgreg((uint16_t)((get_flgreg() & ~FLG_IPL_MASK) | IPM2IPL(intpri)));/* misrac1998 rule 77 argument type*/
}

#define t_set_ipm(intpri)	x_set_ipm(intpri)
#define i_set_ipm(intpri)	x_set_ipm(intpri)


Inline PRI
x_get_ipm(void)
{
	return (IPL2IPM(get_flgreg()));
}

#define i_get_ipm()	x_get_ipm()
#define t_get_ipm()	t_get_ipm()

/*
 *  (3) ݏf(ݗvC)
 */

/*
 *  ݐ䃌WX^̃AhXe[u (prc_config.c)
 *    ݔԍ(INTNO) 犄ݐ䃌WX^̃AhX擾邽߂ɎgpD
 */
extern volatile uint8_t * const intc_reg[];

/*
 *  ݗṽx`e[u (kernel_cfg.c ɂo)
 *    ݔԍ(INTNO) 犄ݗDx擾邽߂ɎgpD
 */
extern const PRI intpri_table[];

/*
 *  ݗv֎~tÕZbg
 *    w肵ݔԍɑΉ銄ݗvC̊ݗvtOZbgD
 *    ݑݒ肳ĂȂݗvC̊ݔԍw肵
 *    ꍇ́CP FALSE ԂD
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	/* x`0łꍇCFG_INTĂȂ */
	if(intpri_table[intno] == 0U)
	{
		return (false);
	}
	*intc_reg[intno] &= ~INTC_LVLMASK;
	
	return(true);
}

#define t_disable_int(intno)	x_disable_int(intno)
#define i_disable_int(intno)	x_disable_int(intno)

/*
 *  ݗv֎~tÕNA
 *    w肵ݔԍɑΉ銄ݗvC̊ݗvtONAD
 *    ݑݒ肳ĂȂݗvC̊ݔԍw肵
 *    ꍇ́CP FALSE ԂD
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	/* x`0łꍇCFG_INTĂȂ */
	if(intpri_table[intno] == 0u)
	{
		return (false);
	}
	/* ݃xɖ߂ */
	*intc_reg[intno] = (*intc_reg[intno] & ~INTC_LVLMASK) | IPM2ILVL(intpri_table[intno]);
	
	return(true);
}

#define t_enable_int(intno)		x_enable_int(intno)
#define i_enable_int(intno)		x_enable_int(intno)


/*
 *  ݗṽNA
 */
Inline void
x_clear_int(INTNO intno)
{
	*(intc_reg[intno]) &= ~INTC_IRMASK;
}

#define t_clear_int(intno)		x_clear_int(intno)
#define i_clear_int(intno)		x_clear_int(intno)


/*
 *  ݗṽ`FbN
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	return (((*intc_reg[intno] & INTC_IRMASK) == INTC_IRMASK)? true : false);
}

#define t_probe_int(intno)		x_probe_int(intno)
#define i_probe_int(intno)		x_probe_int(intno)

/*
 *  ݗvC̑̐ݒ (prc_config.c)
 */
extern void	x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  (4) ݏf(݃nh)
 */

/*
 *  ݃nh̐ݒ
 *
 *  M16CROMɊ݃xN^zu邽߁C{֐͋֐ŎD
 */
Inline void
x_define_inh(INHNO inhno, FP inthdr)
{
}

/*
 *  ݃nh̓ŕKvIRC
 *
 */
Inline void
i_begin_int(INTNO intno)
{
	/* ɍsׂ͂Ȃ */
}

/*
 *  ݃nh̏oŕKvIRC
 *
 */
Inline void
i_end_int(INTNO intno)
{
	/* ɍsׂ͂Ȃ */
}



/*
 *  (5) CPUOf
 */

/*
 *  CPUOnh̐ݒ
 *    M16C  ROM ɃxN^zu邽߁C{֐͋֐ŎD
 */
Inline void x_define_exc(EXCNO excno, FP exchdr);	/* misrac:1998 rule 71 prototype */
 
Inline void
x_define_exc(EXCNO excno, FP exchdr)
{
}

/*
 *  (6) EI
 */

/*
 *  vZbTˑ̏(prc_config.c)
 */
extern void	prc_initialize(void);

/*
 *  dispatcher ĂяoOɃ^[QbgˑŕKvȏs߂̊֐
 *    (prc_config.c)
 */
extern void start_dispatch(void);

/*
 *  J[l̏Ǐďoiprc_config.cj
 *
 *  call_exit_kerneĺCJ[l̏IɌĂяoCX^bN|C^
 *  CJ[l̏Iiexit_kerneljĂяoD
 */
extern void call_exit_kernel(void);

/*
 *  vZbTˑ̏I(prc_config.c)
 */
extern void	prc_terminate(void);

/*
 *  (7) dispacher ł̊ݑ҂
 */
 
Inline void idle_loop(void);	/* misrac:1998 rule 71 prototype */

Inline void
idle_loop(void)
{
	t_unlock_cpu();
	t_lock_cpu();
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
