/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2007 by Witz Corporation, JAPAN
 *  Copyright (C) 2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *  t_stddef.h̊JˑilTXNCXXpj
 *
 *  ̃CN[ht@ĆCtarget_stddef.h ̐擪ŃCN[hD
 */

#if !defined( TOPPERS_TOOL_STDDEF_H )
#define TOPPERS_TOOL_STDDEF_H

/*
 *  RpC̊g@\̂߂̃}N`
 */
/*
 *  inline ʎq̓RpCT|[gĂ邽߁CRgAEgƂD
 *  Cnc30, nc308 RpC inline  Inline ̈ӖƓl
 *  RpCPʂɃ[JȃCC֐łD̂߁CGCC Ɠl
 *  inline ͗płȂߒӂKvłD
 */
#define	inline
#define	Inline		_inline

/*
 *  asm ʎq̓RpCT|[gĂ邽߁CRgAEgƂD
 *  nc30, nc308 RpC asm  Asm ̈ӖƓlōœK}~D
 */
/*#define	asm		_asm	*/
#define	Asm		_asm

/*
 *  ^[Ȃ֐ł邱Ƃ߂̃L[[h
 *      ۂɂ͉Ȃ
 */
#define NoReturn


/*
 *  J̕WCN[ht@C̗p
 *
 *  NULL̒`stddef.hCINT_MAXCINT_MINCUINT_MAXCLONG_MAXC
 *  LONG_MINCULONG_MAXCCHAR_BIT̒`limits.h荞ށD
 */
#ifndef TOPPERS_MACRO_ONLY
#include <stddef.h>
#include <limits.h>
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  stdint.h̑pƂȂ`
 *
 *  C99  stdint.h pӂĂȂ߁C̑pƂȂ`^D
 */

/*
 *  RpCˑ̃f[^^̒`
 */
#ifndef TOPPERS_MACRO_ONLY

typedef signed char			int8_t;		/* t8rbg */
typedef unsigned char		uint8_t;	/* 8rbg */

typedef signed short		int16_t;	/* t16rbg */
typedef unsigned short		uint16_t;	/* 16rbg */

typedef signed long			int32_t;	/* t32rbg */
typedef unsigned long		uint32_t;	/* 32rbg */

typedef signed long long	int64_t;	/* t64rbg */
typedef unsigned long long	uint64_t;	/* 64rbg */

typedef int8_t          	int_least8_t;	/* 8rbgȏ̕t */
typedef uint8_t         	uint_least8_t;	/* 8rbgȏ̕ */

typedef long				intptr_t;	/* |C^i[ł镄t */
typedef unsigned long		uintptr_t;	/* |C^i[ł镄 */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  RpCˑ̃f[^^̐萔}N(C99)
 *  pӂĂȂ߁CŒ`D
 */
#ifndef INT8_C
#define INT8_C(val)			(val)
#endif /* INT8_C */

#ifndef UINT8_C
#define UINT8_C(val)		(val ## U)
#endif /* UINT8_C */

#ifndef INT16_C
#define INT16_C(val)		(val)
#endif /* INT16_C */

#ifndef UINT16_C
#define UINT16_C(val)		(val ## U)
#endif /* UINT16_C */

#ifndef INT32_C
#define INT32_C(val)		(val)
#endif /* INT32_C */

#ifndef UINT32_C
#define UINT32_C(val)		(val ## U)
#endif /* UINT32_C */

#ifndef INT64_C
#define INT64_C(val)		(val ## LL)
#endif /* INT64_C */

#ifndef UINT64_C
#define UINT64_C(val)		(val ## ULL)
#endif /* UINT64_C */

/*
 *  RpCˑ̃f[^^Ɋi[łőlƍŏl̒`(C99)
 *  pӂĂȂ߁CŒ`D
 */
#define INT8_MAX			SCHAR_MAX
#define INT8_MIN			SCHAR_MIN
#define UINT8_MAX			UCHAR_MAX

#define INT16_MAX			SHRT_MAX
#define INT16_MIN			SHRT_MIN
#define UINT16_MAX			USHRT_MAX

#define INT32_MAX			LONG_MAX
#define INT32_MIN			LONG_MIN
#define UINT32_MAX			ULONG_MAX

#define INT64_MAX			LLONG_MAX
#define INT64_MIN			LLONG_MIN
#define UINT64_MAX			ULLONG_MAX

#define INT_LEAST8_MAX		INT8_MAX
#define INT_LEAST8_MIN		INT8_MIN
#define UINT_LEAST8_MAX		INT8_MAX

/*
 *  _^Ɋւ`
 */
#ifndef TOPPERS_MACRO_ONLY

typedef float		float32_t;			/* IEEE754̒Px_ */
typedef double		double64_t;			/* IEEE754̔{x_ */

#endif /* TOPPERS_MACRO_ONLY */

#define FLOAT32_MIN		1.17549435e-38F
#define FLOAT32_MAX		3.40282347e+38F
#define DOUBLE64_MIN	2.2250738585072014e-308
#define DOUBLE64_MAX	1.7976931348623157e+308

/*
 *  󃉃x̒`
 *    ncXX ł͑傫[̔z̓RpCG[ɂȂ邽߁A
 *    ŕʓr`B
 */
#define TOPPERS_EMPTY_LABEL(x,y) x y[1]

#endif /* TOPPERS_TOOL_STDDEF_H */

