/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2012 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 		 logtask.c 
 */
/* Copyright(C)2014 by Dr.OGAWA Kiyoshi, MISRAC Stydy Group/SESSAME/Japan
 * misrac1998̌ɊÂĉMmisrac:1998ƋLځB
 * misrac2004, misrac2012̌ʂɂĂ͉MO̕悢ꍇB
 * r̂߂ɋLqBłɍ̗pꍇɁAes̒LĂ悢B
 */ 
/*
 *		VXeO^XN
 */

#include <kernel.h>
#include <t_syslog.h>
#include <log_output.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "logtask.h"

/*
 *  VXeO^XN̏o͐̃|[gID
 */
static ID	logtask_portid;

/*
 *  VAC^tF[Xւ1o
 */
static void
logtask_putc(char_t c)
{
	serial_wri_dat(logtask_portid, &c, 1U); /* misrac:1998 rule 13 basic type */ 
}

/*
 *  O^XN̏
 */

void logtask_initialize(ID log_portid)
{
	logtask_portid = log_portid;
	serial_opn_por(logtask_portid);
	syslog_msk_log(LOG_UPTO(LOG_NOTICE), LOG_UPTO(LOG_EMERG));
	syslog_1(LOG_NOTICE, "System logging task is started on port %d.",
													logtask_portid);
}
/*
 *  VXeO^XN̖{
 */
void
logtask_main(intptr_t exinf)
{
	SYSLOG syslog;
	static uint_t	lost = 0U;	/* misrac1998 rule 18 numeric constant */ 
	ER_UINT	rercd;
	
	while ((rercd = syslog_rea_log(&syslog)) >= 0) {
		lost += (uint_t) rercd;
		if (syslog.logtype >= LOG_TYPE_COMMENT) {
			if (lost > 0U) {
				syslog_lostmsg(lost, logtask_putc);
				lost = 0U;
			}
			syslog_print(&syslog, logtask_putc);/* misrac1998 rule 77 argument type *//* syslogconst錾syslog_rea_logŌxo*/
			logtask_putc((uint8_t)'\n');/* misrac1998 rule 77 argument type */
		}
	}
	if (lost > 0U) {
		syslog_lostmsg(lost, logtask_putc);
	}
}

void cychdr_act_logtsk(intptr_t exinf)
{
	iact_tsk((ID)exinf);
}

/*
 *  VXeO^XN̏I
 */
void
logtask_terminate(intptr_t exinf)
{
	char_t	c;
	SYSLOG	syslog;
	bool_t	msgflg = false;
	ER_UINT	rercd;

	/*
	 *  VAC^tF[XhCȏMobt@ɒ~ςꂽf[^
	 *  C჌xo͋@\pďo͂D
	 */
	while (serial_get_chr(logtask_portid, &c)) {
		target_fput_log(c);
	}

	/*
	 *  Oobt@ɋL^ꂽOC჌xo͋@\pďo
	 *  ͂D
	 */
	while ((rercd = syslog_rea_log(&syslog)) >= 0) {
		if (!msgflg) {
			/*
			 *  Oobt@ɎcOł邱Ƃo
			 *  ͂D
			 */
			syslog_printf("-- buffered messages --\n", NULL, target_fput_log);
			msgflg = true;
		}
		if (rercd > 0) {
			syslog_lostmsg((uint_t) rercd, target_fput_log);
		}
		if (syslog.logtype >= LOG_TYPE_COMMENT) {
			syslog_print( &syslog, target_fput_log);/* misrac1998 rule 77 argument type */
			target_fput_log((uint8_t)'\n');/* misrac1998 rule 77 argument type */
		}
	}
}
