/* cfg1_out.c */
#define TOPPERS_CFG1_OUT  1
#include "kernel/kernel_int.h"
#include "sample1.h"
#include "target_timer.h"
#include "target_syssvc.h"
#include "target_syssvc.h"
#include "target_serial.h"
#include "syssvc/serial.h"
#include "syssvc/banner.h"
#include "syssvc/syslog.h"
#include "syssvc/logtask.h"


#ifdef INT64_MAX
  typedef int64_t signed_t;
  typedef uint64_t unsigned_t;
#else
  typedef int32_t signed_t;
  typedef uint32_t unsigned_t;
#endif

#include "target_cfg1_out.h"

const uint32_t TOPPERS_cfg_magic_number = 0x12345678;
const uint32_t TOPPERS_cfg_sizeof_signed_t = sizeof(signed_t);
const uint32_t TOPPERS_cfg_sizeof_pointer = sizeof(const volatile void*);
const unsigned_t TOPPERS_cfg_CHAR_BIT = ((unsigned char)~0u == 0xff ? 8 : 16);
const unsigned_t TOPPERS_cfg_CHAR_MAX = ((char)-1 < 0 ? (char)((unsigned char)~0u >> 1) : (unsigned char)~0u);
const unsigned_t TOPPERS_cfg_CHAR_MIN = ((char)-1 < 0 ? -((unsigned char)~0u >> 1) - 1 : 0);
const unsigned_t TOPPERS_cfg_SCHAR_MAX = (signed char)((unsigned char)~0u >> 1);
const unsigned_t TOPPERS_cfg_SHRT_MAX = (short)((unsigned short)~0u >> 1);
const unsigned_t TOPPERS_cfg_INT_MAX = (int)(~0u >> 1);
const unsigned_t TOPPERS_cfg_LONG_MAX = (long)(~0ul >> 1);

const unsigned_t TOPPERS_cfg_SIL_ENDIAN_BIG = 
#if defined(SIL_ENDIAN_BIG)
(1);
#else
(0);
#endif
const unsigned_t TOPPERS_cfg_SIL_ENDIAN_LITTLE = 
#if defined(SIL_ENDIAN_LITTLE)
(1);
#else
(0);
#endif
const unsigned_t TOPPERS_cfg_TA_NULL = ( unsigned_t )TA_NULL;
const unsigned_t TOPPERS_cfg_TA_ACT = ( unsigned_t )TA_ACT;
const unsigned_t TOPPERS_cfg_TA_RSTR = ( unsigned_t )TA_RSTR;
const unsigned_t TOPPERS_cfg_TA_STA = ( unsigned_t )TA_STA;
const unsigned_t TOPPERS_cfg_TA_CLR = ( unsigned_t )TA_CLR;
const unsigned_t TOPPERS_cfg_TA_NONKERNEL = ( unsigned_t )TA_NONKERNEL;
const unsigned_t TOPPERS_cfg_TA_ENAINT = ( unsigned_t )TA_ENAINT;
const unsigned_t TOPPERS_cfg_TA_EDGE = ( unsigned_t )TA_EDGE;
const unsigned_t TOPPERS_cfg_DEFAULT_ISTKSZ = ( unsigned_t )DEFAULT_ISTKSZ;
const signed_t TOPPERS_cfg_TMIN_TPRI = ( signed_t )TMIN_TPRI;
const signed_t TOPPERS_cfg_TMAX_TPRI = ( signed_t )TMAX_TPRI;
const signed_t TOPPERS_cfg_TMIN_ISRPRI = ( signed_t )TMIN_ISRPRI;
const signed_t TOPPERS_cfg_TMAX_ISRPRI = ( signed_t )TMAX_ISRPRI;
const unsigned_t TOPPERS_cfg_TBIT_FLGPTN = ( unsigned_t )TBIT_FLGPTN;
const unsigned_t TOPPERS_cfg_TMAX_RELTIM = ( unsigned_t )TMAX_RELTIM;
const signed_t TOPPERS_cfg_TMIN_INTPRI = ( signed_t )TMIN_INTPRI;
const unsigned_t TOPPERS_cfg_OMIT_INITIALIZE_INTERRUPT = 
#if defined(OMIT_INITIALIZE_INTERRUPT)
(1);
#else
(0);
#endif
const unsigned_t TOPPERS_cfg_OMIT_INITIALIZE_EXCEPTION = 
#if defined(OMIT_INITIALIZE_EXCEPTION)
(1);
#else
(0);
#endif
const unsigned_t TOPPERS_cfg_sizeof_ID = ( unsigned_t )sizeof(ID);
const unsigned_t TOPPERS_cfg_sizeof_uint_t = ( unsigned_t )sizeof(uint_t);
const unsigned_t TOPPERS_cfg_sizeof_SIZE = ( unsigned_t )sizeof(SIZE);
const unsigned_t TOPPERS_cfg_sizeof_ATR = ( unsigned_t )sizeof(ATR);
const unsigned_t TOPPERS_cfg_sizeof_PRI = ( unsigned_t )sizeof(PRI);
const unsigned_t TOPPERS_cfg_sizeof_void_ptr = ( unsigned_t )sizeof(void*);
const unsigned_t TOPPERS_cfg_sizeof_VP = ( unsigned_t )sizeof(void*);
const unsigned_t TOPPERS_cfg_sizeof_intptr_t = ( unsigned_t )sizeof(intptr_t);
const unsigned_t TOPPERS_cfg_sizeof_FP = ( unsigned_t )sizeof(FP);
const unsigned_t TOPPERS_cfg_sizeof_INHNO = ( unsigned_t )sizeof(INHNO);
const unsigned_t TOPPERS_cfg_sizeof_INTNO = ( unsigned_t )sizeof(INTNO);
const unsigned_t TOPPERS_cfg_sizeof_EXCNO = ( unsigned_t )sizeof(EXCNO);
const unsigned_t TOPPERS_cfg_TKERNEL_PRVER = ( unsigned_t )TKERNEL_PRVER;
const unsigned_t TOPPERS_cfg_TA_LOWLEVEL = ( unsigned_t )TA_LOWLEVEL;
const unsigned_t TOPPERS_cfg_TA_HIGHLEVEL = ( unsigned_t )TA_HIGHLEVEL;
const unsigned_t TOPPERS_cfg_TA_NEGEDGE = ( unsigned_t )TA_NEGEDGE;


/* #include "sample1.h" */
/* #include "target_timer.h" */

#line 6 "../../../../../target/rsk_m32c87_hew/target_timer.cfg"
const unsigned_t TOPPERS_cfg_static_api_0 = 0;
const unsigned_t TOPPERS_cfg_valueof_iniatr_0 = ( unsigned_t )( TA_NULL ); 
#line 7 "../../../../../target/rsk_m32c87_hew/target_timer.cfg"
const unsigned_t TOPPERS_cfg_static_api_1 = 1;
const unsigned_t TOPPERS_cfg_valueof_teratr_1 = ( unsigned_t )( TA_NULL ); 
#line 8 "../../../../../target/rsk_m32c87_hew/target_timer.cfg"
const unsigned_t TOPPERS_cfg_static_api_2 = 2;
const unsigned_t TOPPERS_cfg_valueof_inhno_2 = ( unsigned_t )( INHNO_TIMER ); const unsigned_t TOPPERS_cfg_valueof_inhatr_2 = ( unsigned_t )( TA_NULL ); 
#line 9 "../../../../../target/rsk_m32c87_hew/target_timer.cfg"
const unsigned_t TOPPERS_cfg_static_api_3 = 3;
const unsigned_t TOPPERS_cfg_valueof_intno_3 = ( unsigned_t )( INTNO_TIMER ); const unsigned_t TOPPERS_cfg_valueof_intatr_3 = ( unsigned_t )( TA_ENAINT ); const signed_t TOPPERS_cfg_valueof_intpri_3 = ( signed_t )( INTPRI_TIMER ); /* #include "target_syssvc.h" */
/* #include "target_syssvc.h" */
/* #include "target_serial.h" */

#line 8 "../../../../../target/rsk_m32c87_hew/target_serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_4 = 4;
const unsigned_t TOPPERS_cfg_valueof_iniatr_4 = ( unsigned_t )( TA_NULL ); 
#line 10 "../../../../../target/rsk_m32c87_hew/target_serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_5 = 5;
const unsigned_t TOPPERS_cfg_valueof_intno_5 = ( unsigned_t )( INTNO_SIOP1_RCV ); const unsigned_t TOPPERS_cfg_valueof_intatr_5 = ( unsigned_t )( INTATR_SIOP1_RCV ); const signed_t TOPPERS_cfg_valueof_intpri_5 = ( signed_t )( INTPRI_SIOP1_RCV ); 
#line 11 "../../../../../target/rsk_m32c87_hew/target_serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_6 = 6;
const unsigned_t TOPPERS_cfg_valueof_intno_6 = ( unsigned_t )( INTNO_SIOP1_SND ); const unsigned_t TOPPERS_cfg_valueof_intatr_6 = ( unsigned_t )( INTATR_SIOP1_SND ); const signed_t TOPPERS_cfg_valueof_intpri_6 = ( signed_t )( INTPRI_SIOP1_SND ); 
#line 13 "../../../../../target/rsk_m32c87_hew/target_serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_7 = 7;
const unsigned_t TOPPERS_cfg_valueof_isratr_7 = ( unsigned_t )( TA_NULL ); const unsigned_t TOPPERS_cfg_valueof_intno_7 = ( unsigned_t )( INTNO_SIOP1_RCV ); const signed_t TOPPERS_cfg_valueof_isrpri_7 = ( signed_t )( 1 ); 
#line 14 "../../../../../target/rsk_m32c87_hew/target_serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_8 = 8;
const unsigned_t TOPPERS_cfg_valueof_isratr_8 = ( unsigned_t )( TA_NULL ); const unsigned_t TOPPERS_cfg_valueof_intno_8 = ( unsigned_t )( INTNO_SIOP1_SND ); const signed_t TOPPERS_cfg_valueof_isrpri_8 = ( signed_t )( 1 ); /* #include "syssvc/serial.h" */

#line 13 "../../../../../syssvc/serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_9 = 9;
const unsigned_t TOPPERS_cfg_valueof_iniatr_9 = ( unsigned_t )( TA_NULL ); 
#line 14 "../../../../../syssvc/serial.cfg"
const unsigned_t TOPPERS_cfg_static_api_10 = 10;
const unsigned_t TOPPERS_cfg_valueof_teratr_10 = ( unsigned_t )( TA_NULL ); /* #include "syssvc/banner.h" */

#line 10 "../../../../../syssvc/banner.cfg"
const unsigned_t TOPPERS_cfg_static_api_11 = 11;
const unsigned_t TOPPERS_cfg_valueof_iniatr_11 = ( unsigned_t )( TA_NULL ); /* #include "syssvc/syslog.h" */

#line 10 "../../../../../syssvc/syslog.cfg"
const unsigned_t TOPPERS_cfg_static_api_12 = 12;
const unsigned_t TOPPERS_cfg_valueof_iniatr_12 = ( unsigned_t )( TA_NULL ); /* #include "syssvc/logtask.h" */

#line 10 "../../../../../syssvc/logtask.cfg"
const unsigned_t TOPPERS_cfg_static_api_13 = 13;
#define LOGTASK	(<>)

#line 10 "../../../../../syssvc/logtask.cfg"
const unsigned_t TOPPERS_cfg_valueof_tskatr_13 = ( unsigned_t )( TA_ACT ); const signed_t TOPPERS_cfg_valueof_atskpri_13 = ( signed_t )( LOGTASK_PRIORITY ); const unsigned_t TOPPERS_cfg_valueof_stksz_13 = ( unsigned_t )( LOGTASK_STACK_SIZE ); 
#line 12 "../../../../../syssvc/logtask.cfg"
const unsigned_t TOPPERS_cfg_static_api_14 = 14;
#define LOCCYC	(<>)

#line 12 "../../../../../syssvc/logtask.cfg"
const unsigned_t TOPPERS_cfg_valueof_cycatr_14 = ( unsigned_t )( TA_ACT ); const unsigned_t TOPPERS_cfg_valueof_cyctim_14 = ( unsigned_t )( LOGTASK_INTERVAL ); const unsigned_t TOPPERS_cfg_valueof_cycphs_14 = ( unsigned_t )( LOGTASK_INTERVAL ); 
#line 15 "../../../../../syssvc/logtask.cfg"
const unsigned_t TOPPERS_cfg_static_api_15 = 15;
const unsigned_t TOPPERS_cfg_valueof_teratr_15 = ( unsigned_t )( TA_NULL ); 
#line 13 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_16 = 16;
#define INIT_TASK	(<>)

#line 13 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_tskatr_16 = ( unsigned_t )( TA_ACT ); const signed_t TOPPERS_cfg_valueof_atskpri_16 = ( signed_t )( INIT_PRIORITY ); const unsigned_t TOPPERS_cfg_valueof_stksz_16 = ( unsigned_t )( STACK_SIZE ); 
#line 14 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_17 = 17;
#define MAIN_TASK	(<>)

#line 14 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_tskatr_17 = ( unsigned_t )( TA_NULL ); const signed_t TOPPERS_cfg_valueof_atskpri_17 = ( signed_t )( MAIN_PRIORITY ); const unsigned_t TOPPERS_cfg_valueof_stksz_17 = ( unsigned_t )( STACK_SIZE ); 
#line 15 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_18 = 18;
#define TASK1	(<>)

#line 15 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_tskatr_18 = ( unsigned_t )( TA_NULL ); const signed_t TOPPERS_cfg_valueof_atskpri_18 = ( signed_t )( TASK1_PRIORITY ); const unsigned_t TOPPERS_cfg_valueof_stksz_18 = ( unsigned_t )( STACK_SIZE ); 
#line 16 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_19 = 19;
#define TASK2	(<>)

#line 16 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_tskatr_19 = ( unsigned_t )( TA_NULL ); const signed_t TOPPERS_cfg_valueof_atskpri_19 = ( signed_t )( TASK2_PRIORITY ); const unsigned_t TOPPERS_cfg_valueof_stksz_19 = ( unsigned_t )( STACK_SIZE ); 
#line 17 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_20 = 20;
#define TASK3	(<>)

#line 17 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_tskatr_20 = ( unsigned_t )( TA_NULL ); const signed_t TOPPERS_cfg_valueof_atskpri_20 = ( signed_t )( TASK3_PRIORITY ); const unsigned_t TOPPERS_cfg_valueof_stksz_20 = ( unsigned_t )( STACK_SIZE ); 
#line 19 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_21 = 21;
const signed_t TOPPERS_cfg_valueof_exepri_21 = ( signed_t )( TASK3_EXEPRIORITY ); 
#line 21 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_22 = 22;
#define MAIN_CYC	(<>)

#line 21 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_cycatr_22 = ( unsigned_t )( TA_NULL ); const unsigned_t TOPPERS_cfg_valueof_cyctim_22 = ( unsigned_t )( 100 ); const unsigned_t TOPPERS_cfg_valueof_cycphs_22 = ( unsigned_t )( 100 ); 
#line 22 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_23 = 23;
#define CYC1	(<>)

#line 22 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_cycatr_23 = ( unsigned_t )( TA_NULL ); const unsigned_t TOPPERS_cfg_valueof_cyctim_23 = ( unsigned_t )( 2000 ); const unsigned_t TOPPERS_cfg_valueof_cycphs_23 = ( unsigned_t )( 2000 ); 
#line 23 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_24 = 24;
#define ALM1	(<>)

#line 23 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_almatr_24 = ( unsigned_t )( TA_NULL ); 
#line 25 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_25 = 25;
#define FLG1	(<>)

#line 25 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_flgatr_25 = ( unsigned_t )( TA_NULL ); const unsigned_t TOPPERS_cfg_valueof_iflgptn_25 = ( unsigned_t )( 0x00000000 ); 
#line 26 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_26 = 26;
#define DTQ1	(<>)

#line 26 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_valueof_dtqatr_26 = ( unsigned_t )( TA_NULL ); const unsigned_t TOPPERS_cfg_valueof_dtqcnt_26 = ( unsigned_t )( 3 ); 
#line 28 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_27 = 27;
const unsigned_t TOPPERS_cfg_valueof_stksz_27 = ( unsigned_t )( ALL_STACKSIZE ); 
#line 29 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_28 = 28;
const unsigned_t TOPPERS_cfg_valueof_istksz_28 = ( unsigned_t )( INTERRUPT_STACKSIZE ); 
#ifdef CPUEXC1

#line 32 "../../../../../sample/sample1.cfg"
const unsigned_t TOPPERS_cfg_static_api_29 = 29;
const unsigned_t TOPPERS_cfg_valueof_excno_29 = ( unsigned_t )( CPUEXC1 ); const unsigned_t TOPPERS_cfg_valueof_excatr_29 = ( unsigned_t )( TA_NULL ); 
#endif 

