/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                                          RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2003-2004, 2010 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *	^[QbgVXeˑW[iRSK-M32C87 pj
 */

#include "kernel_impl.h"
#include "target_syssvc.h"
#include "target_serial.h"

/*
 *  ^[QbgVXeˑ [`
 */

void
target_initialize(void)
{
	uint8_t tmp;
	
	/* 100słł PD11 ... PD15  0xff ɂ */
	sil_wrb_mem((void *)TADR_PD11, 0xff);
	sil_wrb_mem((void *)TADR_PD12, 0xff);
	sil_wrb_mem((void *)TADR_PD13, 0xff);
	sil_wrb_mem((void *)TADR_PD14, 0xff);
	sil_wrb_mem((void *)TADR_PD15, 0xff);
	
	/*
	 *  ჌xVAo͂̂߂̏
	 */
	/* TxD0 s(p63) ̏ */
	tmp = sil_reb_mem((void *)TADR_PS0); /* TxD */
	tmp |= TBIT_BIT3;
	sil_wrb_mem((void *)TADR_PS0, tmp);

	tmp = sil_reb_mem((void *)TADR_PD6); /* o͂ */
	tmp |= TBIT_BIT3;
	sil_wrb_mem((void *)TADR_PD6, tmp);
	
	/* |[gݒ(샂[hAʐMx) */
	sil_wrb_mem((void *)(TADR_UART0_BASE+TADR_UMR_OFFSET), MR_DEF);
	sil_wrb_mem((void *)(TADR_UART0_BASE+TADR_UC0_OFFSET), C0_DEF);
	sil_wrb_mem((void *)(TADR_UART0_BASE+TADR_UBRG_OFFSET), BRG1_DEF); /* 38400bps */


	/*
	 *  vZbTˑ̏
	 */
	prc_initialize();
}


/*
 *  ^[QbgVXȅI[`
 */

void
target_exit(void)
{
	/* CPUˑ̏I[` */
	prc_terminate();
	
	while (1)
		;
}

/*
 * VXeO̒჌xo͂̂߂̕o
 */
void target_fput_log(char_t c)
{
	if (c == '\n') {
		sys_putc('\r', LOGTASK_PORTID);
	}
	sys_putc(c, LOGTASK_PORTID);
}
