/*
 *  TOPPERS/SSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 *  Copyright (C) 2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
/* Copyright(C)2014 by Dr.OGAWA Kiyoshi, MISRAC Stydy Group/SESSAME/Japan
 * misrac1998̌ɊÂĉMmisrac:1998ƋLځB
 * misrac2004, misrac2012̌ʂɂĂ͉MO̕悢ꍇB
 * r̂߂ɋLqBłɍ̗pꍇɁAes̒LĂ悢B
 */ 
/*
 * VAhCoiRenesas Starter Kit for M32C/87pj
 */

#include <kernel.h>
#include <sil.h>
#include "target_serial.h"
#include "target_syssvc.h"

/*
 *  VAI/O|[gubN̒`
 */
typedef struct sio_port_initialization_block {
	uint8_t 	mr_def;	/* ftHg̐ݒl (MR) */
	uint8_t 	c0_def;	/* ftHg̐ݒl (C0) */
	uint8_t 	brg_def;	/* ftHg̐ݒl (BRG) */

	uint16_t	cntrl_addr;	/* 䃌WX^̔Ԓn */
	INTNO   	intno_snd;	/* Mݔԍ */ 
	INTNO   	intno_rcv;	/* Mݔԍ */
} SIOPINIB;


/*
 *  VAI/O|[gubN
 *
 *  ID = 1 uart0CID = 2 uart1ɑΉĂD
 */
static const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{ MR_DEF, C0_DEF, BRG1_DEF, TADR_UART0_BASE, INTNO_SIOP1_SND, INTNO_SIOP1_RCV  },
#if TNUM_SIOP == 2
	{ MR_DEF, C0_DEF, BRG1_DEF, TADR_UART1_BASE, INTNO_SIOP1_SND, INTNO_SIOP1_RCV  }
#endif
};


/*
 *  VAI/O|[gǗubN
 */
typedef struct sio_port_control_block {
	const SIOPINIB	*siopinib;	/* VAI/O|[gubN */
	intptr_t      	exinf;    	/* g */
	uint8_t       	uc1;      	/* M䃌WX^UiC1̐ݒl */
};

/*
 * VAI/O|[gǗubNGA
 */
static SIOPCB siopcb_table[TNUM_SIOP];


/*
 * WX^ݒl
 */
#define PORT2SIOPID(x)	((x) + 1)
#define INDEX_PORT(x)	((x) - 1)
#define GET_SIOPCB(x)	(&siopcb_table[INDEX_PORT(x)])


/*
 *  SIO
 */
void sio_initialize(intptr_t exinf)
{
	int_t     	i;		/* misrac:1998 rule 13 basic type */
	uint8_t 	tmp;
	const SIOPINIB	*p_siopinib;

	/*
	 *  VAI/O|[gǗubN̏
	 */
	for (i = 0; i < TNUM_SIOP; i++) {
		p_siopinib = &(siopinib_table[i]);
		siopcb_table[i].siopinib = p_siopinib;
		siopcb_table[i].uc1 = C1_DEF;

		/*
		 * IɃ|[gsĂ
		 */
		/* 荞݋֎~ */
		dis_int(p_siopinib->intno_snd);
		dis_int(p_siopinib->intno_rcv);

		/* M֎~ */
		sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UC1_OFFSET), siopcb_table[i].uc1);
	}

	/*
	 * |[g̐ݒ
	 *    |[gP63 TxD0, |[gP62 RxD0 
	 */
	tmp = sil_reb_mem((void *)TADR_PS0);
	tmp &= ~TBIT_BIT2;
	tmp |= TBIT_BIT3;
	sil_wrb_mem((void *)TADR_PS0, tmp);

	tmp = sil_reb_mem((void *)TADR_PD6);
	tmp &= ~TBIT_BIT2;
	tmp |= TBIT_BIT3;
	sil_wrb_mem((void *)TADR_PD6, tmp);
}

/*
 *  VAI[v
 */
SIOPCB *sio_opn_por(ID siopid, intptr_t exinf)
{
	int_t i;
	SIOPCB* p_siopcb;
	const SIOPINIB *p_siopinib;

	if (siopid > TNUM_PORT) {
		return NULL;
	}
	
	p_siopcb = GET_SIOPCB(siopid);
	p_siopinib = p_siopcb->siopinib;

	p_siopcb->exinf = exinf;

	/* M֎~ */
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UC1_OFFSET),
	  (uint8_t)( sil_reb_mem((void *)(p_siopinib->cntrl_addr+TADR_UC1_OFFSET))&~(TBIT_UiC1_TE | TBIT_UiC1_RE)));/* misrac1998 rule 77 argument type Ƃ@T */

	/* |[gݒ(샂[hAʐMx) */
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UMR_OFFSET), p_siopinib->mr_def);
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UC0_OFFSET), p_siopinib->c0_def);
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UBRG_OFFSET), p_siopinib->brg_def);
	
	/* ݋ */
	(void)ena_int(p_siopinib->intno_snd);
	(void)ena_int(p_siopinib->intno_rcv);

	/* I[v̓R[obN֎~ */
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UC1_OFFSET), p_siopcb->uc1);

	/*
	 * _~[f[^M
	 */
	sil_reb_mem((void *)(p_siopinib->cntrl_addr+TADR_URB_OFFSET));
	sil_reb_mem((void *)(p_siopinib->cntrl_addr+TADR_URB_OFFSET));

	for(i = 0 ; i < SFRUART_COUNT ; i++){	/* I[vMREADY܂ő҂ */
		if(sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET)) & TBIT_UiC1_TI){
			break;
		}/* misrac:1998 rule 59 condition block by{} */
	}
	return p_siopcb;
}

/*
 *  VAN[Y
 */
void sio_cls_por(SIOPCB *p_siopcb)
{
	const SIOPINIB	*p_siopinib;

	p_siopinib = p_siopcb->siopinib;

	/* M֎~ */
	p_siopcb->uc1 = C1_DEF;
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UC1_OFFSET), p_siopcb->uc1);

	/* VAW[𖳌ɂ */
	sil_wrb_mem((void *)(p_siopinib->cntrl_addr+TADR_UMR_OFFSET),(uint8_t) MR_DISABLE_DEF);/* misrac1998 rule 77 argument type Ƃ@T */
}


/*
 *  1M
 */
bool_t
sio_snd_chr(SIOPCB *p_siopcb, char_t c)
{
	if(sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET)) & TBIT_UiC1_TI){
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UTB_OFFSET), c);

		return true;
	}
	return false;
}

/*
 *  1M
 */
int_t
sio_rcv_chr(SIOPCB *p_siopcb)
{
	int_t c = -1;

	if(sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET)) & TBIT_UiC1_RI){
		c = (int_t)sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_URB_OFFSET));
	}
	return c;
}

/*
 *  R[obN̋
 */
void
sio_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		p_siopcb->uc1 |= TBIT_UiC1_TE;
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET), p_siopcb->uc1);
		break;
	case SIO_RDY_RCV:
		p_siopcb->uc1 |= TBIT_UiC1_RE;
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET), p_siopcb->uc1);
		break;
	default: break; 	/* misrac:1998 rule 62 default: */
	}
}

/* 
 *  R[obN̋֎~
 */
void
sio_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	case SIO_RDY_SND:
		p_siopcb->uc1 &= ~TBIT_UiC1_TE;
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET), p_siopcb->uc1);
		break;
	case SIO_RDY_RCV:
		p_siopcb->uc1 &= ~TBIT_UiC1_RE;
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET), p_siopcb->uc1);
		break;
	default: break; 	/* misrac:1998 rule 62 default: */
	}
}


/*
 *  ݃T[rX[`
 */

/*
 *  M
 */
void
sio_isr_rcv(intptr_t portid)
{
	SIOPCB *p_siopcb = GET_SIOPCB((ID)portid);

	if((p_siopcb->uc1 & TBIT_UiC1_RE) != 0) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		sio_irdy_rcv(p_siopcb->exinf);
	}
}

/*
 *  M
 */
void
sio_isr_snd(intptr_t portid)
{
	SIOPCB *p_siopcb = GET_SIOPCB((ID)portid);

	if((p_siopcb->uc1 & TBIT_UiC1_TE) != 0) {
		/*
		 *  MʒmR[obN[`ĂяoD
		 */
		sio_irdy_snd(p_siopcb->exinf);
	}
}

/*
 *  1ói|[Oł̏ój
 */
void
sio_pol_snd_chr(char_t c, ID siopid)
{
	SIOPCB *p_siopcb = GET_SIOPCB((ID)siopid);

	uint8_t tmp;
	uint8_t enabled;

	/*  */
	tmp = sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET));
	enabled =(	uint8_t) (tmp & TBIT_UiC1_TE);/* misrac:1998 rule 13 basic type */

	/* MĂȂ΋ */
	if(!enabled) {
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET),(uint8_t) (tmp | TBIT_UiC1_TE));
	}

	/* Mobt@ɂȂ܂ő҂(Lԓ̏) */
	while((sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET)) & TBIT_UiC1_TI) == 0){
	;	/* Mobt@ɂȂ܂ő҂(Lԓ̏) */
	}/* misrac:1998 rule 59 */
	/* 1M */
	sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UTB_OFFSET), c);

	if(!enabled) {
		tmp = sil_reb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET));
		sil_wrb_mem((void *)(p_siopcb->siopinib->cntrl_addr+TADR_UC1_OFFSET), (uint8_t)(tmp & ~TBIT_UiC1_TE));
	}
}
